BuffInformant_Options = LibStub('AceAddon-3.0'):NewAddon('BuffInformant')

BuffInformant_Options.newbuff = {}

function BuffInformant_Options:OnInitialize()

	local L = BuffInformant_Locale

	BuffInformant:SetDirectConfigMode(false)
	self:ClearNewBuff()

	-- configuration
	SLASH_BUFFINFORMANT1 = '/buffinformant';
	SLASH_BUFFINFORMANT2 = '/bi';
	SlashCmdList['BUFFINFORMANT'] = function()
		InterfaceOptionsFrame_OpenToCategory(LibStub('AceConfigDialog-3.0').BlizOptions['BuffInformant'].frame)
	end
	
	local options = {
		type = 'group',
		name = 'BuffInformant',
		desc = [[]],
		handler = self,
		get = 'GetSetting',
		set = 'SetSetting',
		args = {
			grp_newbuff = {
				order = 1,
				type = 'group',
				inline = true,
				name = L['grp_newbuff_name'],
				desc = L['grp_newbuff_desc'],
				args = {
					name = {
						order = 2,
						type = 'input',
						name = L['nb_name_name'],
						desc = L['nb_name_desc'],
						get = 'GetNewbuff',
						set = 'SetNewbuff',
					},
					display = {
						order = 3,
						type = 'select',
						name = L['nb_display_name'],
						desc = L['nb_display_desc'],
						get = 'GetNewbuff',
						set = 'SetNewbuff',
						values = {
							[1] = L['nb_display_1'],
							[2] = L['nb_display_2'],
							[3] = L['nb_display_3'],
							[4] = L['nb_display_4'],
							[5] = L['nb_display_5'],
						},
					},
					unit = {
						order = 4,
						type = 'select',
						name = L['nb_unit_name'],
						desc = L['nb_unit_desc'],
						get = 'GetNewbuff',
						set = 'SetNewbuff',
						values = {
							['player'] = L['nb_unit_player'],
							['target'] = L['nb_unit_target'],
							['pet'] = L['nb_unit_pet'],
						},
					},
					restrict = {
						order = 5,
						type = 'input',
						name = L['nb_restrict_name'],
						desc = L['nb_restrict_desc'],
						get = 'GetNewbuff',
						set = 'SetNewbuff',
					},
					text = {
						order = 6,
						type = 'input',
						name = L['nb_text_name'],
						desc = L['nb_text_desc'],
						get = 'GetNewbuff',
						set = 'SetNewbuff',
					},
					nbshowicon = {
						order = 7,
						type = 'select',
						name = L['nb_showicon_name'],
						desc = L['nb_showicon_desc'],
						get = 'GetNewbuff',
						set = 'SetNewbuff',
						values = {
							['D'] = L['showicon_D'],
							['Y'] = L['showicon_Y'],
							['N'] = L['showicon_N'],
						},
					},
					add = {
						order = 10,
						type = 'execute',
						name = L['nb_add_name'],
						desc = L['nb_add_desc'],
						disabled = function()
							return self.newbuff.name == '' or self.newbuff.display == 1
						end,
						func = function()
							local line = self.newbuff.name
							local Sdisplay = {[2] = 'S', [3] = 'E', [4] = 'B', [5] = 'T'}
							line = line .. '|D=' .. Sdisplay[self.newbuff.display]
							if self.newbuff.restrict ~= '' then
								line = line .. '|C=' .. self.newbuff.restrict
							end -- if
							if self.newbuff.unit ~= 'player' then
								line = line .. '|U=' .. self.newbuff.unit
							end -- if
							if self.newbuff.text ~= '' then
								line = line .. '|T=' .. self.newbuff.text
							end -- if
							if self.newbuff.nbshowicon ~= 'D' then
								line = line .. '|I=' .. self.newbuff.nbshowicon
							end -- if
							local list = BuffInformant:GetPref('list')
							if list ~= '' then
								list = list .. "\n"
							end -- if
							BuffInformant:SetPref('list', list .. line)
							self:ClearNewBuff()
		--					LibStub("AceConfigDialog-3.0"):ConfigTableChanged(nil, 'BuffInformant')
						end,
					},
				},
			},
			grp_list = {
				order = 20,
				type = 'group',
				inline = true,
				name = L['grp_list_name'],
				desc = L['grp_list_desc'],
				args = {
					list = {
						order = 21,
						type = 'input',
						name = L['list_name'],
						desc = L['list_desc'],
						multiline = true,
						width = 'full',
					},
				},
			},
			grp_display = {
				order = 30,
				type = 'group',
				inline = true,
				name = L['grp_display_name'],
				desc = L['grp_display_desc'],
				args = {
					locked = {
						order = 31,
						type = 'toggle',
						name = L['locked_name'],
						desc = L['locked_desc'],
						get = function() return not BuffInformant:GetLocked() end,
						set = function(_, val) BuffInformant:SetLocked(not val) end,
					},
					font = {
						order = 32,
						type = 'select',
						name = L['font_name'],
						desc = L['font_desc'],
						values = {
							['NumberFontNormal'] = 'NumberFontNormal',
							['NumberFontNormalLarge'] = 'NumberFontNormalLarge',
							['NumberFontNormalHuge'] = 'NumberFontNormalHuge',
							['GameFontNormal'] = 'GameFontNormal',
							['GameFontNormalLarge'] = 'GameFontNormalLarge',
							['GameFontNormalHuge'] = 'GameFontNormalHuge',
							['ChatFontNormal'] = 'ChatFontNormal',
							['SystemFont'] = 'SystemFont',
							['MailTextFontNormal'] = 'MailTextFontNormal',
							['QuestTitleFont'] = 'QuestTitleFont',
						}
					},
					insertmode = {
						order = 33,
						type = 'select',
						name = L['insertmode_name'],
						desc = L['insertmode_desc'],
						values = {
							['TOP'] = L['insertmode_TOP'],
							['BOTTOM'] = L['insertmode_BOTTOM'],
						}
					},
					showicon = {
						order = 34,
						type = 'select',
						name = L['showicon_name'],
						desc = L['showicon_desc'],
						values = {
							['Y'] = L['showicon_Y'],
							['N'] = L['showicon_N'],
						},
					},
					holdtime = {
						order = 35,
						type = 'range',
						name = L['holdtime_name'],
						desc = L['holdtime_desc'],
						min = 1,
						max = 10,
						step = 0.1,
					},
					colors = {
						order = 40,
						type = 'group',
						inline = true,
						name = L['grp_colors_name'],
						desc = L['grp_colors_desc'],
						args = {
							buffstartcolor = {
								order = 30,
								type = 'color',
								name = L['buffstartcolor_name'],
								desc = L['xbuffxxxcolor_desc'],
								get = 'GetColorSetting',
								set = 'SetColorSetting',
							},
							buffendcolor = {
								order = 31,
								type = 'color',
								name = L['buffendcolor_name'],
								desc = L['xbuffxxxcolor_desc'],
								get = 'GetColorSetting',
								set = 'SetColorSetting',
							},
							debuffstartcolor = {
								order = 32,
								type = 'color',
								name = L['debuffstartcolor_name'],
								desc = L['xbuffxxxcolor_desc'],
								get = 'GetColorSetting',
								set = 'SetColorSetting',
							},
							debuffendcolor = {
								order = 33,
								type = 'color',
								name = L['debuffendcolor_name'],
								desc = L['xbuffxxxcolor_desc'],
								get = 'GetColorSetting',
								set = 'SetColorSetting',
							},
						},
					},
				},
			},
			grp_version = {
				order = 100,
				type = 'header',
				name = string.format(L['grp_version_name'], string.gsub(GetAddOnMetadata('BuffInformant', 'Version'), '@project%-revision@', 'svn'), 'r' .. BuffInformant.Version),
				desc = L['grp_version_desc'],
			},
		}
	}
	LibStub('AceConfigRegistry-3.0'):RegisterOptionsTable('BuffInformant', options)
	local blizz = LibStub("AceConfigDialog-3.0"):AddToBlizOptions('BuffInformant', 'BuffInformant')
	blizz.obj:SetCallback('okay', BuffInformant_Options.Okay)
	blizz.obj:SetCallback('cancel', BuffInformant_Options.Cancel)
	blizz.obj:SetCallback('defaults', BuffInformant_Options.Defaults)
	
	LibStub:GetLibrary("LibDataBroker-1.1"):NewDataObject("BuffInformant", {
		type = "launcher",
		text = "BuffInformant",
		OnClick = function(_, msg)
			if msg == "LeftButton" then
				BuffInformant:SetLocked(not BuffInformant:GetLocked())
			elseif msg == "RightButton" then
				InterfaceOptionsFrame_OpenToCategory(LibStub('AceConfigDialog-3.0').BlizOptions['BuffInformant'].frame)
			end -- if
		end,
		icon = "Interface\\Icons\\Spell_Nature_Regeneration",
		OnTooltipShow = function(tooltip)
			if tooltip and tooltip.AddLine then
				tooltip:AddLine('|cffffffffBuffInformant')
				tooltip:AddLine(L['broker_tooltip'])
			end -- if
		end,
	})
end

function BuffInformant_Options:GetNewbuff(info)
	local key = info[#info]
	return self.newbuff[key]
end

function BuffInformant_Options:SetNewbuff(info, value)
	local key = info[#info]
	self.newbuff[key] = value
end

function BuffInformant_Options:GetSetting(info)
	local key = info[#info]
	return BuffInformant:GetPref(key)
end

function BuffInformant_Options:SetSetting(info, value)
	local key = info[#info]
	
	if value == BuffInformant:GetPref(key) then
		return
	end
	
	BuffInformant:SetPref(key, value)
	
	BuffInformant:Update(key)
end

function BuffInformant_Options:GetColorSetting(info)
	local key = info[#info]
	return BuffInformant:GetColorPref(key)
end

function BuffInformant_Options:SetColorSetting(info, r, g, b, a)
	local key = info[#info]
	BuffInformant:SetColorPref(key, r, g, b, a)
	BuffInformant:Update(false)
end

function BuffInformant_Options:ClearNewBuff()
	self.newbuff.name = ''
	self.newbuff.display = 1
	self.newbuff.restrict = ''
	self.newbuff.unit = 'player'
	self.newbuff.text = ''
	self.newbuff.nbshowicon = 'D'
end

function BuffInformant_Options.Okay()
	BuffInformant:ConfigOkay()
end

function BuffInformant_Options.Cancel()
	BuffInformant:ConfigCancel()
end

function BuffInformant_Options.Defaults()
	BuffInformant:ConfigDefaults()
end

